<template>
    <div class="loader"
         :style="{
            background: backgroundColor,
            visibility: isVisible ? '' : 'hidden',
            position: isFixed ? 'fixed' : '',
         }"
    >
        <div class="loader-content">
            <div class="loader-content__cell loader-content__cell-1">
                <div class="loader__waiting-title">
                    <template v-if="!Array.isArray(waitingTitleContent)">
                        {{waitingTitleContent}}
                    </template>
                    <slot name="waitingTitle"/>
                </div>
                <SVGIcon class="loader__svg-spinner"
                         xlink="processing"
                         :viewBox="viewBox"
                />
            </div>
            <div class="loader-content__cell loader-content__cell-2 loader__caption">
                <slot name="caption"/>
                <template v-if="!Array.isArray(captionContent)">
                    {{captionContent}}
                </template>
            </div>
        </div>
    </div>
</template>

<script>
	import SVGIcon from '../SVGIcon/index';

	export default {
		name: 'Loader',

		components: {
			SVGIcon
		},

		props: {
		    size: {
		        type: Number,
                required: false,
            },
			name: {
			    type: String,
                required: true,
            },
            isShow: {
			    type: Boolean,
                default: false,
            },
			isFixed: {
				type: Boolean,
				default: false,
			},
			backgroundColor: {
				type: String,
				default: 'rgba(255, 255, 255, .75)',
			},
			waitingTitle: {
				/*строка или массив с VNodes*/
				type: [String, Array],
				default: '',
			},
			caption: {
				/*строка или массив с VNodes*/
				type: [String, Array],
				default: '',
			},
		},

		data() {
			return {
				waitingTitleContent: null,
				captionContent: null,
                isVisible: this.isShow,
			};
		},

        computed: {
		    viewBox () {
		        if (this.size) {
		            return `0 0 ${this.size} ${this.size}`
                } else {
		            return `0 0 185 185`
                }
            }
        },

        watch: {
			isShow: {
				handler(newValue) {
					if(newValue) {
						this.show();
                    } else {
						this.hide();
                    }
				},
                immediate: true,
            },
        },

        methods: {
			show() {
				this.$store.commit('ADD_ACTIVE_LOADER_COMPONENT_EXEMPLAR', {
					name: this.name,
                    componentExemplar: this,
                });
				this.isVisible = true;
				this.$emit('showed');
            },
            hide() {
				this.waitingTitleContent = '';
				this.captionContent = '';
				this.$store.commit('REMOVE_ACTIVE_LOADER_COMPONENT_EXEMPLAR', this.name);
				this.$emit('hided');
            },
        },

		created() {
			this.$watch('waitingTitle', newValue => {
				this.waitingTitleContent = newValue;
			}, {
				immediate: true,
            });
			this.$watch('waitingTitleContent', newValue => {
				/*если контент был передан слотом, или текстом*/
				if(Array.isArray(newValue)) {
					this.$slots.waitingTitle = newValue;
                }
			}, {
				immediate: true,
			});
			this.$watch('caption', newValue => {
				this.captionContent = newValue;
			}, {
				immediate: true,
			});
			this.$watch('captionContent', newValue => {
				/*если контент был передан слотом, или текстом*/
				if(Array.isArray(newValue)) {
					this.$slots.caption = newValue;
				}
			}, {
				immediate: true,
			});
		},

        beforeDestroy() {
			this.hide();
		},
	}
</script>


<style lang="scss" scoped>
    .loader {
        width: 100%;
        height: 100%;
        position: absolute;
        z-index: 1;
        top: 0;
        left: 0;
        display: flex;
        align-items: center;
        justify-content: center;
    }

    .loader-content {
        position: relative;
        display: inline-flex;
        flex-direction: column;
        align-items: center;
        justify-content: center;
        text-align: center;
        padding: 20px;
        max-width: 100%;
    }

    .loader-content__cell {
        display: flex;
        align-items: center;
        justify-content: center;
    }

    .loader-content__cell-1 {
        position: relative;
    }

    .loader-content__cell-2 {
        margin-top: 35px;
    }

    .loader__svg-spinner {
        max-width: 100%;
        animation: infinite 1s rotate linear;
    }

    .loader__waiting-title {
        position: absolute;
        width: 100%;
        height: 100%;
        display: flex;
        align-items: center;
        justify-content: center;
        padding: 25px;
    }

    .loader__caption {
        max-width: 350px;
    }

    @keyframes rotate {
        from {
            transform: rotate(0);
        }
        to {
            transform: rotate(360deg);
        }
    }
</style>
